# @file
#
# Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2013
# Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2013
#
# See the file LICENSE.txt in the package base directory for details
# 
# - Find md5sum
# This module looks for the md5sum command. 
# It will set the following variables:
#  MD5SUM = the md5sum command if found
#
# @author Tobias Hilbrich
#

INCLUDE(FindPackageHandleStandardArgs)

FIND_PROGRAM (MD5SUM NAMES md5sum PATH /usr/bin /bin /local/bin /usr/local/bin)
MARK_AS_ADVANCED(FORCE MD5SUM)

find_package_handle_standard_args(MD5SUM  DEFAULT_MSG MD5SUM)