/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2013
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2013
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file I_CollMatchListener.h
 *       @see I_CollMatchListener.
 *
 *  @date 10.08.2011
 *  @author Tobias Hilbrich, Joachim Protze, Mathias Korepkat
 */

#include "BaseIds.h"
#include "MustEnums.h"
#include "MustTypes.h"
#include "I_Comm.h"

#ifndef I_COLLMATCHLISTENER_H
#define I_COLLMATCHLISTENER_H

namespace must
{
    /**
     * Interface to be implemented by listeners on collective matches.
     */
    class I_CollMatchListener
    {
    public:

        /**
         * Called when a new collective is completly matched.
         * @param comm only valid until this call returns.
         */
        virtual void newMatch (
                MustCollCommType collId,
                I_Comm* comm) = 0;

    };/*class I_CollMatchListener*/
} /*namespace must*/

#endif /*I_COLLMATCHLISTENER_H*/
