/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2013
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2013
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file DWaitStateCollMgr.h
 *       @see DWaitStateCollMgr.
 *
 *  @date 05.03.2013
 *  @author Tobias Hilbrich
 */

#include "ModuleBase.h"
#include "I_ParallelIdAnalysis.h"
#include "I_CommTrack.h"
#include "I_DWaitStateCollMgr.h"
#include "DistributedDeadlockApi.h"

#ifndef DWAITSTATECOLLMGR_H
#define DWAITSTATECOLLMGR_H

using namespace gti;

namespace must
{
    /**
     * Implementation of I_DWaitStateCollMgr.
     * @see I_DWaitStateCollMgr
     */
    class DWaitStateCollMgr
        : public gti::ModuleBase<DWaitStateCollMgr, I_DWaitStateCollMgr>
    {
    public:
        /**
         * Constructor.
         * @param instanceName name of this module instance.
         */
        DWaitStateCollMgr (const char* instanceName);

            /**
             * Destructor.
             */
        virtual ~DWaitStateCollMgr (void);

        /**
         * @see I_DWaitStateCollMgr::request
         */
        GTI_ANALYSIS_RETURN request (
                int isIntercomm,
                unsigned long long contextId,
                int localGroupSize,
                int remoteGroupSize,
                int numTasks,
                I_ChannelId* cId);

    protected:
            generateCollectiveActiveAcknowledgeP myFAcknowledge;
            I_ParallelIdAnalysis* myPIdMod;
            I_CommTrack *myCommTrack;
    };
} /*namespace MUST*/

#endif /*DWAITSTATECOLLMGR_H*/
