/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2013
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2013
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file FinalizeNotify.h
 *       @see MUST::FinalizeNotify.
 *
 *  @date 04.04.2011
 *  @author Tobias Hilbrich
 */

#include "ModuleBase.h"

#include "I_FinalizeNotify.h"

#ifndef FINALIZENOTIFY_H
#define FINALIZENOTIFY_H

using namespace gti;

namespace must
{
	/**
     * Template for correctness checks interface implementation.
     */
    class FinalizeNotify : public gti::ModuleBase<FinalizeNotify, I_FinalizeNotify>
    {
    public:
        /**
         * Constructor.
         * @param instanceName name of this module instance.
         */
    		FinalizeNotify (const char* instanceName);

    		/**
    		 * Destructor.
    		 */
    		virtual ~FinalizeNotify (void);

    		/**
    		 * @see I_FinalizeNotify::notify.
    		 */
    		GTI_ANALYSIS_RETURN notify ();

    protected:
    };
} /*namespace MUST*/

#endif /*FINALIZENOTIFY_H*/
