/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2010-2013
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2010-2013
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file ParallelIdImpl.h
 *       Implementation for the parallel id analysis interface.
 *
 *  @date 07.01.2010
 *  @author Tobias Hilbrich
 */

#include "ModuleBase.h"
#include "I_ParallelIdAnalysis.h"

#ifndef PARALLELIMPL_H
#define PARALLELIMPL_H

using namespace gti;

namespace must
{
	/**
     * Implementation for the parallel id analysis.
     */
    class ParallelIdImpl : public gti::ModuleBase<ParallelIdImpl, I_ParallelIdAnalysis>
    {
    protected:

    public:
        /**
         * Constructor.
         * @param instanceName name of this module instance.
         */
    		ParallelIdImpl (const char* instanceName);

        /**
         * @see I_ParallelIdAnalysis::getInfoForId.
         */
    		ParallelInfo getInfoForId (MustParallelId id);

    		/**
    		 * @see I_ParallelIdAnalysis::toString.
    		 */
    		std::string toString (MustParallelId id);
    }; /*class ParallelIdImpl */
} /*namespace MUST*/

#endif /*PARALLELIMPL_H*/
