/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2013
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2013
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file datatypeTest.h
 * Testoutput for datatypes.
 *
 * @author Joachim Protze
 */

#include <mpi.h>
#include <stdio.h>
#include "mustFeaturetested.h"
#include "MustTypes.h"

#ifndef DATATYPETEST_H
#define DATATYPETEST_H

inline void test_btype(MPI_Datatype datatype) 
{
    MustDatatypeType fType = MUST_Type_m2i (datatype);
    MPI_Initialized ((int*)&fType);
}

inline void test_type(MPI_Datatype datatype) 
{
    MustDatatypeType fType = MUST_Type_m2i (datatype);
    int size;
    MPI_Aint lb, extent, ub;
    MPI_Initialized ((int*)&fType);
    MPI_Type_commit(&datatype);
    MPI_Type_size(datatype, &size);
    printf("\nMPI_Type_size(%i)\n",size);
#ifdef HAVE_MPI_TYPE_GET_EXTENT
    MPI_Type_get_extent(datatype, &lb, &extent);
    printf("MPI_Type_get_extent(%li, %li)\n", lb, extent);
#endif
#ifdef HAVE_MPI_TYPE_GET_TRUE_EXTENT
    MPI_Type_get_true_extent(datatype, &lb, &extent);
    printf("MPI_Type_get_true_extent(%li, %li)\n", lb, extent);
#endif
    MPI_Type_lb(datatype, &lb);
    printf("MPI_Type_lb(%li)\n", lb);
    MPI_Type_extent(datatype, &extent);
    printf("MPI_Type_extent(%li)\n", extent);
    MPI_Type_ub(datatype, &ub);
    printf("MPI_Type_ub(%li)\n\n", ub);
    fType = MUST_Type_m2i (datatype);
    MPI_Initialized ((int*)&fType);
}
#endif /*DATATYPETEST_H*/
