/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2013
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2013
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file PrintErr.h
 *       @see MUST::PrintErr.
 *
 *  @date 12.05.2011
 *  @author Tobias Hilbrich
 */

#include "ModuleBase.h"
#include "I_CreateMessage.h"

#include "I_PrintErr.h"

#ifndef PRINTERR_H
#define PRINTERR_H

using namespace gti;

namespace must
{
	/**
     * Implementation of I_PrintErr.
     */
    class PrintErr : public gti::ModuleBase<PrintErr, I_PrintErr>
    {
    public:
        /**
         * Constructor.
         * @param instanceName name of this module instance.
         */
    		PrintErr (const char* instanceName);

    		/**
    		 * Destructor.
    		 */
    		virtual ~PrintErr (void);

    		/**
    		 * @see I_PrintErr::print.
    		 */
    		GTI_ANALYSIS_RETURN print (
    				MustParallelId pId,
    				MustLocationId lId,
    				MustErrType err);

    protected:
    		I_CreateMessage* myLogger;
    		I_ErrTrack* myErrTracker;
    		I_LocationAnalysis* myLocations;
    }; /*class PrintErr */
} /*namespace MUST*/

#endif /*PRINTERR_H*/
